# -*- coding: utf-8 -*-
import re, urllib2, time
import xml.etree.cElementTree as tree

from pycri.plugins import Plugin

class Spotify(Plugin):

    apiurl = "http://ws.spotify.com/lookup/"
    apiversion = '1'

    def timeconversion(self, seconds):
        format = '%H:%M:%S'
        if seconds < 3600:
            format = format[3:]
        return time.strftime(format, time.gmtime(seconds))
        

    def on_privmsg(self, irc, prefix, params):
        channel = params[0]
        msg = params[-1]

        m = re.search('(http://open\.spotify\.com/|spotify:)(album|artist|track)[:/]([^\s$]+)', msg)

        if not m:
            return
        uri = 'spotify:{}:{}'.format(m.group(2), m.group(3))
        data = self.call(uri)
        xml = tree.fromstring(data)

        # TODO: Iterate through the xml-element instead of relying on the currently working xml-structure (ie. length does not always have the same placement in the xml-structure)
        if m.group(2) == 'album':
            ret = u"» {0} [{1}] » {2}".format(xml[1][0].text, xml[0].text, uri)
        elif m.group(2) == 'track':
            # This is needed since the placement for the length-element varies.
            length = 0
            for e in xml.iter():
                if e.tag.endswith('length'):
                    length = e.text
            ret = u"» {0} - {1} [{2}] ({3}) » {4}".format(xml[1][0].text, xml[0].text, xml[2][0].text, self.timeconversion(float(length)), uri)
        elif m.group(2) == 'artist':
            ret = u"» {0} » {1}".format(xml[0].text, uri)

        irc.msg(channel, ret)
        return


    def call(self, uri):
        url = ''.join([self.apiurl, self.apiversion, '/?uri=', uri])
        data = urllib2.urlopen(url).read()

        return data
